/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.ui;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import kinugasa.object.Model;

/**
 * kinugasa : LabelModel : ラベルのテキストを描画するモデルです.
 * <br>
 * ラベルの表示文字インデックスの更新とその検査はこのモデルの描画メソッド内で
 * 行う必要があります。<br>
 * 
 * @version 1.0.0 - 2012/07/16_14:22:53.<br>
 * @version 2.0.0 - 2012/11/26_::.<br>
 * @author Dra0211<br>
 * <br>
 * 
 */
public abstract class LabelModel extends Model {

	/** 標準のフォントです. 変更しない場合はMONOSPACE, PLAIN, 16ptのフォントが設定されています. */
	private static Font DEFALUT_FONT = new Font(Font.MONOSPACED, Font.PLAIN, 16);
	/** 標準のフォントカラーです. 変更しない場合はColor.ORANGEが設定されています. */
	private static Color DEFULT_COLOR = Color.ORANGE;
	private static final long serialVersionUID = 3188375963284932612L;

	/**
	 * デフォルトコンストラクタを使用してラベルモデルを作成した際に設定される
	 * フォントを取得します.
	 * 
	 * @return 標準のフォント.<Br>
	 */
	public static Font getDefaultFont() {
		return DEFALUT_FONT;
	}

	/**
	 * デフォルトコンストラクタを使用してラベルモデルを作成した際に設定される
	 * フォントを設定します.
	 * 
	 * @param font 標準のフォント.<Br>
	 */
	public static void setDefaultFont(Font font) {
		LabelModel.DEFALUT_FONT = font;
	}

	/**
	 * デフォルトコンストラクタを使用してラベルモデルを作成した際に設定される
	 * フォントカラーを取得します.
	 * 
	 * @return 標準のフォントカラー.<Br>
	 */
	public static Color getDefaultColor() {
		return DEFULT_COLOR;
	}

	/**
	 * デフォルトコンストラクタを使用してラベルモデルを作成した際に設定される
	 * フォントカラーを取得します.
	 * 
	 * @param color 標準のフォントカラー.<Br>
	 */
	public static void setDefaultColor(Color color) {
		LabelModel.DEFULT_COLOR = color;
	}
	//
	/** このモデルで使用されるフォント. */
	private Font font;
	/** フォントに設定する色. */
	private Color color;

	/**
	 * 新しいラベルモデルを構築します.
	 * このコンストラクタでは、ラベルモデルのクラスフィールドである標準のフォントおよび
	 * フォントカラーが設定されます.<br>
	 */
	public LabelModel() {
		super();
		font = DEFALUT_FONT;
		color = DEFULT_COLOR;
	}

	/**
	 * 新しいラベルモデルを構築します.
	 * 
	 * @param f フォント.<br>
	 * @param c フォントの色.<br>
	 */
	public LabelModel(Font f, Color c) {
		super();
		this.font = f;
		this.color = c;
	}

	/**
	 * ラベルのテキストを描画します.
	 * 通常は、setPropertyを使用してフォントおよびフォントカラーを
	 * 適用した後、ラベルのgetVisibleTextを使用して取得した可視文字列を
	 * ラベルの座標に描画します。<br>
	 * <br>
	 * このメソッド内でラベルの可視状態や生存状態を評価する必要はありません。<br>
	 * 
	 * @param g 書き込むグラフィックスコンテキスト。<br>
	 * @param l 表示するラベルが送信されます。<br>
	 */
	public abstract void drawText(Graphics2D g, TextLabel l);

	/**
	 * グラフィックスコンテキストにこのラベルモデルに設定されているフォント
	 * およびフォントカラーを設定します.
	 * 
	 * @param g 設定するグラフィックスコンテキスト.<br>
	 */
	protected final void setProperty(Graphics2D g) {
		g.setColor(color);
		g.setFont(font);
	}

	/**
	 * このモデルのフォントカラーを取得します.
	 * 
	 * @return フォントの色.<Br>
	 */
	public final Color getColor() {
		return color;
	}

	/**
	 * フォントの色を設定します.
	 * 
	 * @param color フォントの色.<br>
	 *
	 * @return このインスタンス自体が返る.<br>
	 */
	public final LabelModel setColor(Color color) {
		this.color = color;
		return this;
	}

	/**
	 * フォントのサイズを取得します.
	 * 
	 * @return フォントのサイズ.<br>
	 */
	public final float getFontSize() {
		return font.getSize2D();
	}

	/**
	 * フォントのサイズを設定します.
	 * 
	 * @param size フォントのサイズ.<br>
	 *
	 * @return このインスタンス自体が返る.<br>
	 */
	public final LabelModel setFontSize(float size) {
		font = font.deriveFont(size);
		return this;
	}

	/**
	 * このモデルのフォントを取得します.
	 * 
	 * @return フォント.<br>
	 */
	public final Font getFont() {
		return font;
	}

	/**
	 * このモデルのフォントを取得します.
	 * 
	 * @param font フォント.<br>
	 *
	 * @return このインスタンス自体が返る.<br>
	 */
	public final LabelModel setFont(Font font) {
		this.font = font;
		return this;
	}

	@Override
	public LabelModel clone() {
		return (LabelModel) super.clone();
	}
	/** ラベルの座標にラベルの可視テキストを表示する,標準の実装です. */
	public static final LabelModel STANDARD = new LabelModel() {
		private static final long serialVersionUID = -6879469600761885933L;

		@Override
		public void drawText(Graphics2D g, TextLabel l) {
			setProperty(g);
			g.drawString(l.getVisibleText(), (int) l.getX(), (int) l.getY() + getFontSize());
			if (l.getTimeCounter().isReaching() && !l.isAllTextVisible()) {
				l.nextChar();
			}
		}
	};
}
